题目描述
无聊的wlswls正在观察某个商品的价格,wlswls一共观察了nn天,每天这个商品都会有一个价格p_ipi。
定义一个长度为2m+1(3\leq2m+1\leq n)2m+1(3≤2m+1≤n)的子序列a_1...a_{2m+1}a1...a2m+1是持续下降的,当且仅当:
-
1 \leq a_1 < a_2 < .... < a_{2m+1} \leq n1≤a1<a2<....<a2m+1≤n
-
对于所有的k(1 \leq k \leq m)k(1≤k≤m), p_{a[2k - 1]} > p_{a[2k + 1]} > p_{a[2k]}pa[2k−1]>pa[2k+1]>pa[2k]
现在wlswls想知道持续下降的子序列一共有多少个。
由于满足条件的序列可能很多,请输出答案 modmod 1e9+71e9+7。
输入描述
第一行一个整数nn。
接下来一行nn个整数,p_ipi表示商品第ii天的价格。
1 \leq n \leq 20001≤n≤2000
1 \leq p_i \leq n1≤pi≤n
p_i \neq p_jpi=pj
输出描述
一行一个整数表示答案。
样例输入 1
5 4 2 3 1 5
样例输出 1
1
思路:
我们先来看三个元素组成的持续下降的子序列,
如x,y,z, 那么要求 x>z>y (因为没有相等的两个价值,所以不考虑等于号)
那么我们想一下,如果我们只找三个元素组成的子序列,咋找呢?
我们可以定义dp状态 dp[i] 表示 以第i个元素为结尾的合法子序列个数。
那么我们可以n*n的方式去找,
对于每一个i,我们枚举j=i-1 downto 1 ,维护比a[i] 小的数 的个数 k,
在枚举的过程中,我们遇到一个数a[j] >a[i] 时,我们可以对dp[i] += k ;
为什么? 因为 这个 a[j] 可以和到a[i]中间的那k个比a[i]小的构成三元素合法子序列。
这样我们就解决了三元素合法子序列的问题,
题目要求的并不是三元素子序列,是2*m+1 元素的,三元素只是m=1的情况,。
那么我们不妨来看一下 m=2时。即5个元素的情况,
我们应该知道 5个元素的情况只是在三元素情况上后面加两个数字 q w
构成 x>z>y,z>w>q
观察可得,5元组的第2个大小关系中的最大值,是上一个三元组中的 z,
那么当我们再求第5个元素w的 dp[i]的时候(i是 w的下标 ),我们遇到z的时候,
dp[i]+= (dp[j]+1)*k;
j是比w大的元素z的下标,这样就可以把以z为结尾的所有合法子序列又都贡献到了 dp[i]上,
这样我们就可以n*n的时间复杂度来用dp解决这个问题。
细节见代码:
#include <iostream> #include <cstdio> #include <cstring> #include <algorithm> #include <cmath> #include <queue> #include <stack> #include <map> #include <set> #include <vector> #include <iomanip> #define ALL(x) (x).begin(), (x).end() #define rt return #define dll(x) scanf("%I64d",&x) #define xll(x) printf("%I64d\n",x) #define sz(a) int(a.size()) #define all(a) a.begin(), a.end() #define rep(i,x,n) for(int i=x;i<n;i++) #define repd(i,x,n) for(int i=x;i<=n;i++) #define pii pair<int,int> #define pll pair<long long ,long long> #define gbtb ios::sync_with_stdio(false),cin.tie(0),cout.tie(0) #define MS0(X) memset((X), 0, sizeof((X))) #define MSC0(X) memset((X), '\0', sizeof((X))) #define pb push_back #define mp make_pair #define fi first #define se second #define eps 1e-6 #define gg(x) getInt(&x) #define db(x) cout<<"== [ "<<x<<" ] =="<<endl; using namespace std; typedef long long ll; ll gcd(ll a, ll b) {return b ? gcd(b, a % b) : a;} ll lcm(ll a, ll b) {return a / gcd(a, b) * b;} ll powmod(ll a, ll b, ll MOD) {ll ans = 1; while (b) {if (b % 2)ans = ans * a % MOD; a = a * a % MOD; b /= 2;} return ans;} inline void getInt(int* p); const int maxn = 1000010; const int inf = 0x3f3f3f3f; /*** TEMPLATE CODE * * STARTS HERE ***/ const ll mod = 1e9 + 7; ll n; ll a[maxn]; ll dp[maxn]; int main() { //freopen("D:\\common_text\\code_stream\\in.txt","r",stdin); //freopen("D:\\common_text\\code_stream\\out.txt","w",stdout); gbtb; cin >> n; repd(i, 1, n) { cin >> a[i]; } ll k; repd(j, 3, n) { k = 0ll; for (int i = j - 1; i >= 1; i--) { if (a[i] < a[j]) { k++; } else { dp[j] += (dp[i] + 1) * k; dp[j] %= mod; } } } ll ans = 0ll; repd(i, 3, n) { ans = (ans + dp[i]) % mod; } ans %= mod; cout << ans << endl; return 0; } inline void getInt(int* p) { char ch; do { ch = getchar(); } while (ch == ' ' || ch == '\n'); if (ch == '-') { *p = -(getchar() - '0'); while ((ch = getchar()) >= '0' && ch <= '9') { *p = *p * 10 - ch + '0'; } } else { *p = ch - '0'; while ((ch = getchar()) >= '0' && ch <= '9') { *p = *p * 10 + ch - '0'; } } }